﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;

namespace esl
{
    class CarLoanApplicationREST
    {
        public static void start()
        {
            string apiKey = "YOUR_API_KEY";
            string url = "https://sandbox.esignlive.com/api";

            string jsonString = "{\"type\":\"PACKAGE\",\"status\":\"SENT\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"attachmentRequirements\":[{\"name\":\"Driver License\",\"description\":\"Please upload a copy of your driver license.\",\"required\":\"true\",\"status\":\"INCOMPLETE\"}],\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\",\"auth\":{\"scheme\":\"SMS\",\"challenges\":[{\"question\":\"418-555-5585\"}]}}]},{\"id\":\"Signer2\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail35@mailinator.com\",\"firstName\":\"Patty\",\"lastName\":\"Galant\",\"id\":\"Signer2\",\"auth\":{\"scheme\":\"CHALLENGE\",\"challenges\":[{\"question\":\"What's 1+1?\",\"answer\":\"2\",\"maskInput\":false}]}}]}],\"name\":\"Car Loan Application\",\"documents\":[{\"fields\":[{\"value\":\"50000\",\"name\":\"amount\"},{\"value\":\"mail32@mailinator.com\",\"name\":\"applicant_email\"},{\"value\":\"John Smith\",\"name\":\"applicant_name\"},{\"value\":\"mail35@mailinator.com\",\"name\":\"coapplicant_email\"},{\"value\":\"Patty Galant\",\"name\":\"coapplicant_name\"},{\"value\":\"X\",\"name\":\"radio5\"}],\"extract\":true,\"name\":\"Sample Loan Agreement\",\"id\":\"loan\",\"approvals\":[{\"role\":\"Signer1\",\"fields\":[{\"type\":\"SIGNATURE\",\"extract\":\"true\",\"subtype\":\"FULLNAME\",\"name\":\"applicant_signature\"},{\"type\":\"INPUT\",\"extract\":\"true\",\"binding\":\"{approval.signed}\",\"subtype\":\"LABEL\",\"name\":\"Date\"},{\"type\":\"INPUT\",\"extract\":\"true\",\"subtype\":\"CHECKBOX\",\"name\":\"agree\",\"validation\":{\"required\":\"true\"}},{\"type\":\"INPUT\",\"extract\":\"true\",\"value\":\"X\",\"subtype\":\"RADIO\",\"name\":\"radio1\",\"validation\":{\"enum\":[\"radioGroup\"]}},{\"type\":\"INPUT\",\"extract\":\"true\",\"subtype\":\"RADIO\",\"name\":\"radio2\",\"validation\":{\"enum\":[\"radioGroup\"]}},{\"type\":\"INPUT\",\"extract\":\"true\",\"subtype\":\"RADIO\",\"name\":\"radio3\",\"validation\":{\"enum\":[\"radioGroup\"]}}]},{\"role\":\"Signer2\",\"fields\":[{\"type\":\"SIGNATURE\",\"extract\":\"true\",\"subtype\":\"FULLNAME\",\"name\":\"coapplicant_signature\"}]}]}]}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("../4B-CarLoan.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"4B-CarLoan.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"4B-CarLoan.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
